"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var electron_1 = require("electron");
var fs = require("fs-extra");
var globby = require("globby");
var path = require("path");
var logDir = path.join(electron_1.app.getPath('userData'), 'logs');
function getLogFiles(base, absolute) {
    if (base === void 0) { base = logDir; }
    if (absolute === void 0) { absolute = false; }
    return globby.sync('**/*.{log,old}', { cwd: base, followSymbolicLinks: false, onlyFiles: true, absolute: absolute });
}
exports.getLogFiles = getLogFiles;
function gatherLogs() {
    return __awaiter(this, void 0, void 0, function () {
        var log, relativeFilePaths, relativeFilePaths_1, relativeFilePaths_1_1, relativeFilePath, resolvedPath, fileContent, error_1, e_1_1;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    log = '';
                    relativeFilePaths = getLogFiles();
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 9, 10, 11]);
                    relativeFilePaths_1 = __values(relativeFilePaths), relativeFilePaths_1_1 = relativeFilePaths_1.next();
                    _b.label = 2;
                case 2:
                    if (!!relativeFilePaths_1_1.done) return [3, 8];
                    relativeFilePath = relativeFilePaths_1_1.value;
                    resolvedPath = path.join(logDir, relativeFilePath);
                    log += "\n\n+++++++ " + relativeFilePath + " +++++++\n";
                    _b.label = 3;
                case 3:
                    _b.trys.push([3, 5, , 6]);
                    return [4, fs.readFile(resolvedPath, 'utf-8')];
                case 4:
                    fileContent = _b.sent();
                    log += fileContent || '(no content)\n';
                    return [3, 6];
                case 5:
                    error_1 = _b.sent();
                    log += '(fle not readable)\n';
                    return [3, 6];
                case 6:
                    log += '++++++++++++++++++++++++++++\n';
                    _b.label = 7;
                case 7:
                    relativeFilePaths_1_1 = relativeFilePaths_1.next();
                    return [3, 2];
                case 8: return [3, 11];
                case 9:
                    e_1_1 = _b.sent();
                    e_1 = { error: e_1_1 };
                    return [3, 11];
                case 10:
                    try {
                        if (relativeFilePaths_1_1 && !relativeFilePaths_1_1.done && (_a = relativeFilePaths_1.return)) _a.call(relativeFilePaths_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7];
                case 11: return [2, log || 'No log files found.'];
            }
        });
    });
}
exports.gatherLogs = gatherLogs;
//# sourceMappingURL=loggerUtils.js.map